#!/bin/sh
#FREERTOSDIR=$HOME/devel/FreeRTOS/FreeRTOS/Source/
FREERTOSDIR=freertos-V10.3.0/
GCCDIR=/Applications/STM32CubeIDE.app/Contents/Eclipse/plugins/com.st.stm32cube.ide.mcu.externaltools.gnu-tools-for-stm32.7-2018-q2-update.macos64_1.0.0.201904181610/tools
export PATH=$GCCDIR/bin:$PATH

mkdir freertos-cortexm0p 2>/dev/null
mkdir freertos-cortexm3  2>/dev/null
mkdir freertos-cortexm4f 2>/dev/null
rm -f freertos-cortexm0p/* 2>/dev/null
rm -f freertos-cortexm3/*  2>/dev/null
rm -f freertos-cortexm4f/* 2>/dev/null

echo "Compiling FreeRTOS for CortexM0+"
cp FreeRTOSConfig.h.cortexm0p FreeRTOSConfig.h
arm-none-eabi-gcc "$FREERTOSDIR/portable/MemMang/heap_4.c"    -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/heap_4.o
arm-none-eabi-gcc "$FREERTOSDIR/portable/GCC/ARM_CM0/port.c"  -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/port.o
arm-none-eabi-gcc "$FREERTOSDIR/event_groups.c"               -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/event_groups.o
arm-none-eabi-gcc "$FREERTOSDIR/list.c"                       -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/list.o
arm-none-eabi-gcc "$FREERTOSDIR/queue.c"                      -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/queue.o
arm-none-eabi-gcc "$FREERTOSDIR/stream_buffer.c"              -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/stream_buffer.o
arm-none-eabi-gcc "$FREERTOSDIR/tasks.c"                      -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/tasks.o
arm-none-eabi-gcc "$FREERTOSDIR/timers.c"                     -mcpu=cortex-m0plus -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM0  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm0p/timers.o

echo "Compiling FreeRTOS for CortexM3"
cp FreeRTOSConfig.h.cortexm3 FreeRTOSConfig.h
arm-none-eabi-gcc "$FREERTOSDIR/portable/MemMang/heap_4.c"    -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/heap_4.o
arm-none-eabi-gcc "$FREERTOSDIR/portable/GCC/ARM_CM3/port.c"  -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/port.o
arm-none-eabi-gcc "$FREERTOSDIR/event_groups.c"               -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/event_groups.o
arm-none-eabi-gcc "$FREERTOSDIR/list.c"                       -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/list.o
arm-none-eabi-gcc "$FREERTOSDIR/queue.c"                      -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/queue.o
arm-none-eabi-gcc "$FREERTOSDIR/stream_buffer.c"              -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/stream_buffer.o
arm-none-eabi-gcc "$FREERTOSDIR/tasks.c"                      -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/tasks.o
arm-none-eabi-gcc "$FREERTOSDIR/timers.c"                     -mcpu=cortex-m3     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM3  -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs                   -mfloat-abi=soft -mthumb -o freertos-cortexm3/timers.o

echo "Compiling FreeRTOS for CortexM4F"
cp FreeRTOSConfig.h.cortexm4f FreeRTOSConfig.h
arm-none-eabi-gcc "$FREERTOSDIR/portable/MemMang/heap_4.c"    -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/heap_4.o
arm-none-eabi-gcc "$FREERTOSDIR/portable/GCC/ARM_CM4F/port.c" -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/port.o
arm-none-eabi-gcc "$FREERTOSDIR/event_groups.c"               -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/event_groups.o
arm-none-eabi-gcc "$FREERTOSDIR/list.c"                       -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/list.o
arm-none-eabi-gcc "$FREERTOSDIR/queue.c"                      -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/queue.o
arm-none-eabi-gcc "$FREERTOSDIR/stream_buffer.c"              -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/stream_buffer.o
arm-none-eabi-gcc "$FREERTOSDIR/tasks.c"                      -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/tasks.o
arm-none-eabi-gcc "$FREERTOSDIR/timers.c"                     -mcpu=cortex-m4     -std=gnu11 -g3 -DDEBUG -c -I. -I$FREERTOSDIR/include -O0 -I$FREERTOSDIR/portable/GCC/ARM_CM4F -ffunction-sections -fdata-sections -Wall -fstack-usage -MMD -MP --specs=nano.specs -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -o freertos-cortexm4f/timers.o
